var bindLinkEditor;
var select_interaction, draw_interaction, modify_interaction;
var $geom_type;
var $interaction_type;
var $draw_controls;
var vector_layer;
var vectorSource;

var iconMarkerStyle = new ol.style.Style({
		image : new ol.style.Icon(/** @type {olx.style.IconOptions} */
			({
				anchor : [0.5, 41],
				anchorXUnits : 'fraction',
				anchorYUnits : 'pixels',
				src : './assets/marker_icons/general.png'
			}))
	});

var selectedIconMarkerStyle = new ol.style.Style({
		image : new ol.style.Icon(/** @type {olx.style.IconOptions} */
			({
				anchor : [0.5, 41],
				anchorXUnits : 'fraction',
				anchorYUnits : 'pixels',
				src : './assets/marker_icons/general_r.png'
			}))
	});
	
var polygonStyle = new ol.style.Style({
		stroke : new ol.style.Stroke({
			color : 'rgba(0, 0, 255, 1)',
			width : 1

		}),
		fill : new ol.style.Fill({
			color : 'rgba(0, 0, 255, 0.1)'
		})
	});



function initStaticMarkersEditor() {

	var vectorSourceLabels = new ol.source.Vector();

	var vector_layer_labels = new ol.layer.Vector({
			name : 'labels',
			source : vectorSourceLabels,
			style : labelStyle()
		});

	map.addLayer(vector_layer_labels);
	
	var vectorSourceNav = new ol.source.Vector();

	var vector_layer_nav= new ol.layer.Vector({
			name : 'nav',
			source : vectorSourceNav,
				style : backboneStyle()
		});
		
	
	map.addLayer(vector_layer_nav);

	
	vectorSource = new ol.source.Vector();

	vector_layer = new ol.layer.Vector({
			name : 'markers',
			source : vectorSource,
			style :  markerStyle()
			
		});

	map.addLayer(vector_layer);


	bindLinkEditor = new BindLinkEditor(map, vector_layer);
	
	var backboneJSON = serverConnector.getBackboneJSON();
	if (backboneJSON)
		loadNavLayer(backboneJSON,vectorSourceNav);
	
	var labelsJSON = serverConnector.getLabelsJSON();
	if (labelsJSON)
		loadLabelsLayer(labelsJSON,vectorSourceLabels);
	
	var staticMarkersJSON = serverConnector.getStaticMarkersJSON();
	if (staticMarkersJSON)
		loadStaticMarkersLayer(staticMarkersJSON,vectorSource);
	

	

	$geom_type = $('#geom_type');
	$interaction_type = $('[name="interaction_type"]');
	$draw_controls = $('[id="draw_controls"]');

	$geom_type.on('select', function (e) {
		updateForDraw();
	});

	initForDraw();

	// rebuild interaction when changed
	$interaction_type.on('click', function (e) {
		// add new interaction
		if (this.value === 'draw') {
			initForDraw();
		} else if (this.value === 'modify') {
			initForModify();
		} else if (this.value === 'link') {
			initForLink();
		}
	});
	
	// load locations selection
	

	var select_location_m = $("#select_location_m");
	$(select_location_m).change(function(){
	selectMarkerForPinboard();
	});
	
	var locationsList = serverConnector.getLocationsList();
	locationsList.sort(function(a, b){
	 var nameA=a.name.toLowerCase(), nameB=b.name.toLowerCase();
	 if (nameA < nameB) //sort string ascending
	  return -1;
	 if (nameA > nameB)
	  return 1;
	 return 0; //default return value (no sorting)
	});
	
	
	$.each(locationsList, function (item) {
		var option = locationsList[item];
		select_location_m.append($("<option />").val(option.id).text(option.name));
	
	});
	
    updateSelectPinboardList(); 
	 
	// load locations
	var select_location = $("#select_location");

	$.each(locationsList, function (item) {
		var option = locationsList[item];
		select_location.append($("<option />").val(option.id).text(option.name));
	
	});
	
   // load preview icon options
	var previewImageURL = $("#popupPreviewURL");
	$.each(staticMarkersPreviewIcons, function (item) {
		var labelIcon = staticMarkersPreviewIcons[item];
		previewImageURL.append($("<option />").val(labelIcon).text(labelIcon));
	});
	
		var marker_type = $("#marker_type");
		
	$.each(markerOptions, function (item) {
		var option = markerOptions[item];
		marker_type.append($("<option />").val(option).text(option));
	});
	
     

$("#popupPreviewURL").bind('change', function(e) {
	$("#popupPreviewImg").attr('src',$("#popupPreviewURL").val());  
});


$("#lang").bind('change', function(e) {
	if(selectedfeature)
selectFeatureForPropertiesEdit(selectedfeature)
});


//	map.on('pointermove', function (evt) {
		
	//});

map.on('click', function (evt) {
	     popup.hide();
		
	//	var pixel = map.getPixelFromCoordinate(evt.coordinate);
	//	var feature = map.forEachFeatureAtPixel(pixel,
		//		function (feature) {
			//	if (feature.get("type") == "st-marker" ) {
			//		var coord = feature.getGeometry().getCoordinates();
			//		popup.show(coord, feature.getId() + ':' + feature.get('popupHeading'));
			//	} 
			//});
			
		
	
	});
	
	var animals = [
				"australian_nightlife",
				"australian_rainforest_aviary",
				"barbary_sheep",
				"binturong",
				"bird",
				"bird2",
				"birds3",
				"bongo",
				"bush_birds",
				"cassowary",
				"chimpanzees",
				"condor",
				"corroboree_frogs",
				"crocodile",
				"Deer",
				"echidna",
				"elephants",
				"emu",
				"fennec_foxes",
				"fishing_cat",
				"freshwater_crocodile",
				"gibbons",
				"giraffe",
				"goats",
				"gorillas",
				"himalayan_tahr",
				"kangaroo",
				"koalas",
				"komodo_dragon",
				"leaf_monkey",
				"lemur",
				"male_elephants",
				"meerkats",
				"otters",
				"palm_aviary",
				"parrots",
				"pelicans",
				"penguins",
				"platapus",
				"pygmy_hippo2",
				"pygmy_hippo2-001",
				"quokka",
				"rabbit",
				"red_kandaroo",
				"red_panda",
				"reptiles",
				"rock_wallaby",
				"seals",
				"sharks",
				"sheep",
				"spiders",
				"sun_bear",
				"tamarins",
				"tasmanian_devil",
				"tortoise",
				"tree_kangaroo",
				"wallaby",
				"wetland_aviary",
				"wetland_birds",
				"wombat_burrow",
				"zebras",
	]
	var out = '';
	var out1 = '';
	var template ="'animal' : {'normal' : new ol.style.Style({image : new ol.style.Icon(({"+
				"anchor : [0.5, 0.5],"+
				"anchorXUnits : 'fraction',"+
				"anchorYUnits : 'fraction',"+
				"scale:0.5,"+
				"src : './assets/marker_icons/animal.png'"+
			"}))"+
	"}),"+	
	"'default_preview' : './assets/marker_icons/animal-selected-preview.jpg'"+	
	"},"+
	""

	//for (var i = 0; i < animals.length; i++) {
	//	var animal = animals[i];
	//	var s =template.replace(/animal/g, animal);
	//	out=out+s;
	//	out1=out1+','+ animal;
	//	}
		
	//	console.log(out);
	//			console.log(out1);
}

function initForDraw() {
	////console.log("initForDraw");
	resetPropertiesEditStyle();
	$(document).off('keyup');
	$draw_controls.show();
	$("#select_location_m").hide();
	map.removeInteraction(select_interaction);
	map.removeInteraction(modify_interaction);
	map.removeInteraction(draw_interaction);

	addSelectInteraction();
	addDrawInteraction();
	addConnectionMode = false;
	bindLinkEditor.unregisterCreateLinkEvents();
	resetSelectedFeaturePropertiesDisplay();
}
function updateForDraw() {
	////console.log("updateForDraw");
	resetPropertiesEditStyle();
	$(document).off('keyup');
	map.removeInteraction(draw_interaction);
	addDrawInteraction();
	addConnectionMode = false;
	resetSelectedFeaturePropertiesDisplay();
}

function initForModify() {
	$(document).off('keyup');
	$draw_controls.hide();
	$("#select_location_m").show();
	map.removeInteraction(select_interaction);
	map.removeInteraction(draw_interaction);
	map.removeInteraction(modify_interaction);
	addSelectInteraction();
	addModifyInteraction();
	addConnectionMode = false;

	resetSelectedFeaturePropertiesDisplay();
	bindLinkEditor.unregisterCreateLinkEvents();

}

function initForLink() {
	$(document).off('keyup');
	$draw_controls.hide();
	$("#select_location_m").show();
	map.removeInteraction(select_interaction);
	map.removeInteraction(modify_interaction);
	map.removeInteraction(draw_interaction);
	addConnectionMode = true;
	resetSelectedFeaturePropertiesDisplay();
	bindLinkEditor.registerCreateLinkEvents();
}

// build up modify interaction
// needs a select and a modify interaction working together


function addSelectInteraction() {

	// remove draw interaction
	// create select interaction
	select_interaction = new ol.interaction.Select({
			// make sure only the desired layer can be selected
			layers : function (vector_layer) {
				return vector_layer.get('name') === 'markers';
			},
			filter : function (feature, layer) {
				//console.log("filter: " + feature.get("type"));
				if (feature.get("type") == "st-marker" )
					return feature;
				else
					return null;
			}
		});
	select_interaction.on('select', select);
	map.addInteraction(select_interaction);
	var selected_features = select_interaction.getFeatures();

}

function deleteItem(selected_feature, select_interaction) {
	var selected_features = select_interaction.getFeatures();
	selected_features.remove(selected_feature);
	vector_layer.getSource().removeFeature(selected_feature);
	resetSelectedFeaturePropertiesDisplay();
	bindLinkEditor.updateLinksOnDelete(selected_feature);
}

function addModifyInteraction() {

	var selected_features = select_interaction.getFeatures();

	// create the modify interaction
	modify_interaction = new ol.interaction.Modify({

			features : selected_features,
			// delete vertices by pressing the SHIFT key
			deleteCondition : function (event) {
				return ol.events.condition.shiftKeyOnly(event) &&
				ol.events.condition.singleClick(event);
			}
		});
	// add it to the map
	map.addInteraction(modify_interaction);
	modify_interaction.on('modifystart', modifystart);
	modify_interaction.on('modifyend', modifyend, null);
	//  modify_interaction.on('propertychange', propertychange,null);
	//  modify_interaction.on('change', change,null);

}

function select(evt) {
	////console.log("select_interaction: select=" + evt.selected);
	resetPropertiesEditStyle();
	var feature = evt.selected[0];
	if (feature) {
		if (feature.get("type") == "st-marker" ) {
			selectFeatureForPropertiesEdit(evt.selected[0]);

		} else if (feature.get("type") == "nav-node") {
			//alert("nav node selected");
		}

	}

}

function modifyend(evt) {
	// //console.log("modifyend");
	updateSelectedFeatureCoordinates();
	bindLinkEditor.updateLinkPositionOnModifyEnd(evt);

}

function modifystart(evt) {}

// creates a draw interaction
function addDrawInteraction() {
	// remove other interactions
	////console.log("addDrawInteraction");

	var value = $geom_type.val();
	if (value !== 'None') {
		var geometryFunction,
		maxPoints;
		if (value === 'Square') {
			value = 'Circle';
			geometryFunction = ol.interaction.Draw.createRegularPolygon(4);
		} else if (value === 'Box') {
			value = 'LineString';
			maxPoints = 2;
			geometryFunction = function (coordinates, geometry) {
				if (!geometry) {
					geometry = new ol.geom.Polygon(null);
				}
				var start = coordinates[0];
				var end = coordinates[1];
				geometry.setCoordinates([
						[start, [start[0], end[1]], end, [end[0], start[1]], start]
					]);
				return geometry;
			};
		}
		draw_interaction = new ol.interaction.Draw({
				source : vector_layer.getSource(),
				type : /** @type {ol.geom.GeometryType} */
				(value),
				geometryFunction : geometryFunction,
				maxPoints : maxPoints
			});

	}

	// add it to the map
	map.addInteraction(draw_interaction);

	draw_interaction.on('drawend', function (event) {
		
		// create a unique id
		
		var id = uid("SM");
		event.feature.setId(id);

		event.feature.set('gType', $geom_type.val());
	    event.feature.set('type', "st-marker");
		
		var value = $geom_type.val();


		if (value == "Square") {
			//event.feature.set('type', "text-label");
			//	event.feature.setStyle(polygonStyle);
		}

		if (value == "Box") {
			//event.feature.set('type', "text-label");
			//	event.feature.setStyle(polygonStyle);
		}
		if (value == "Circle") {
			//event.feature.set('type', "text-label");

			//	event.feature.setStyle(polygonStyle);
		}
		if (value == "Polygon") {
			//event.feature.set('type', "text-label");
			//	event.feature.setStyle(polygonStyle);
		}


		if ($geom_type.val() == "Point") {

		//	event.feature.set('type', "img-label");
			//event.feature.setStyle(iconMarkerStyle);
			event.feature.set('marker_type',defaultMarkerOption)
			
			polygon = isInsidePolygon(event.feature.getGeometry().getCoordinates());

			if (polygon) {
				////console.log('polygon' + polygon);
			}

		}

	});

}



function isInsidePolygon(coord) {
	var pixel = map.getPixelFromCoordinate(coord);
	////console.log('pixel' + pixel);
	var feature = map.forEachFeatureAtPixel(pixel,
			function (feature) {
			if (feature.get("type") == "Polygon")
				return feature;
			else
				return null;
		});

	return feature;

}

function onPointerDown(evt) {
	////console.log('map:onPointerDown');

}
function onPointerUp(evt) {
	////console.log('map:onPointerUp');

}


var savedData;

function saveData() {
	var dataToSave = {};
console.log('save data: ');
	var features = vector_layer.getSource().getFeatures();
	for (var i = 0; i < features.length; i++) {
		var feature = features[i];

		if (feature.get("type") == "st-marker" && feature.get('gType') == "Polygon") {
			//console.log('found polygon: ' + feature.getId());
			var polygonData = {};
			var id = feature.getId();
			polygonData['id'] = feature.getId();
			polygonData['type'] = feature.get('type');
			polygonData['gType'] = feature.get('gType');
			polygonData['marker_type'] = feature.get('marker_type');
			polygonData['location_id'] = feature.get('location_id');
			polygonData['coord'] = feature.getGeometry().getCoordinates();
			
			
			polygonData['popupPreviewURL'] = feature.get('popupPreviewURL');
			polygonData['popupHeading'] = feature.get('popupHeading');
			polygonData['popupText'] = feature.get('popupText');
			polygonData['popupHeadingIntl'] = feature.get('popupHeadingIntl');
			polygonData['popupTextIntl'] = feature.get('popupTextIntl');
			// get points
			var pointLinksData = {};
			if (feature['links-bbn']) {
				for (var l = 0; l < feature['links-bbn'].length; l++) {
					var linkData = {};
					var link = feature['links-bbn'][l];
					var destinationPoint;
					destinationPoint = link['endFeature'];
			
					if (destinationPoint.get("type") == "nav-node") {
						linkData["type"] = "link-bbn";
						linkData["destNode"] = destinationPoint.getId();

					} else if (destinationPoint.get("type") == "connect-node-bbl") {
						var hostLink = destinationPoint['hostLink'];
						var startNode = hostLink['startPoint'];
						var endNode = hostLink['endPoint'];

						linkData["type"] = "connect-node-bbl"
							//linkData["hostLink"] = hostLink.getId();
							//	//console.log('startNode ' + startNode.get("type"));

							linkData["startPoint"] = startNode['id'];
						linkData["endPoint"] = endNode['id'];
						linkData["hostLink"] = hostLink.getId();
						linkData["coord"] = destinationPoint.getGeometry().getCoordinates();
					}

					pointLinksData[destinationPoint.getId()] = linkData;
				}
				polygonData['links-bbn'] = pointLinksData;
			}
			dataToSave[id] = polygonData;
		}
		////console.log('found point: ' + feature.get("type"));
		if (feature.get("type") == "st-marker" && feature.get('gType') == "Point") {
			//	//console.log('found point: ' + feature.getId());
			var pointData = {};
			var id = feature.getId();
			
			pointData['id'] = feature.getId();
			pointData['type'] = feature.get('type');
			pointData['gType'] = feature.get('gType');
			pointData['marker_type'] = feature.get('marker_type');
			if(feature.get('location_id')){
			//	console.log( feature.get('popupPreviewURL') +feature.get('location_id'));
				pointData['location_id'] = feature.get('location_id');	
			}

			pointData['coord'] = feature.getGeometry().getCoordinates();
			pointData['lonLat'] = ol.proj.toLonLat(feature.getGeometry().getCoordinates());
			pointData['popupPreviewURL'] = feature.get('popupPreviewURL');
			pointData['popupHeading'] = feature.get('popupHeading');
			pointData['popupText'] = feature.get('popupText');
			pointData['popupHeadingIntl'] = feature.get('popupHeadingIntl');
			pointData['popupTextIntl'] = feature.get('popupTextIntl');
			// get points
			var pointLinksData = {};
			if (feature['links-bbn']) {
				for (var l = 0; l < feature['links-bbn'].length; l++) {
					var linkData = {};
					var link = feature['links-bbn'][l];
					var destinationPoint;
					destinationPoint = link['endFeature'];
							
					if (destinationPoint.get("type") == "nav-node" || destinationPoint.get("type") == "nav-node-bbl"  ) {
						linkData["type"] = "link-bbn";
						linkData["destNode"] = destinationPoint.getId();

					} else if (destinationPoint.get("type") == "connect-node-bbl") {
						console.log(destinationPoint.get("type"));
						var hostLink = destinationPoint['hostLink'];
						var startNode = hostLink['startPoint'];
						var endNode = hostLink['endPoint'];

						linkData["type"] = "connect-node-bbl"
							linkData["hostLink"] = hostLink.getId();
						////console.log('startNode ' + startNode.get("type"));
						linkData["hostLink"] = hostLink.getId();
						linkData["startPoint"] = startNode.getId();
						linkData["endPoint"] = endNode.getId();
						linkData["coord"] = destinationPoint.getGeometry().getCoordinates();
					}

					pointLinksData[destinationPoint.getId()] = linkData;
				}
				pointData['links-bbn'] = pointLinksData;
			}

			dataToSave[id] = pointData;
		}
	}

	var s = JSON.stringify(dataToSave);
	$('#data').val(s);
	savedData = s;
	serverConnector.saveData("static_markers_json",s);
}

function loadData() {
	var s = $('#data').val();
	////console.log('load: '+s );
	removeAllFeatures()
	loadStaticMarkersLayer(s,vectorSource);

}

function removeAllFeatures() {
var features = vector_layer.getSource().getFeatures();
	for (var i = 0; i < features.length; i++) {
	     vectorSource.removeFeature(features[i])
	}

}

function downloadData() {
	if(savedData){
		download("static_markers_json.js", 'localData_static_markers_json = ' +  savedData );
	}
}


function download(filename, text) {
	var element = document.createElement('a');
	element.setAttribute('href', 'data:text/javascript;charset=utf-8,' + encodeURIComponent(text));
	element.setAttribute('download', filename);

	element.style.display = 'none';
	document.body.appendChild(element);

	element.click();

	document.body.removeChild(element);
}




function selectFeatureForPropertiesEdit(feature) {
	if (feature) {
		selectedfeature = feature;
		//console.log("selectFeatureForPropertiesEdit"+feature.getId());
	    if( feature.get("gType")=="Point"){
		// feature.setStyle(selectedIconMarkerStyle);
		feature.set('isSelected',true)
         var marker_type = feature.get('marker_type')
			feature.setStyle(markerStyles[marker_type]['normal']);	

			
		 }

		$('#editData').show();

		var $selectedFeatureID = $('#selectedFeatureID');
		var $selectedFeatureCoord = $('#selectedFeatureCoord');
		var $marker_type = $('#marker_type');

		var $popupPreviewURL = $('#popupPreviewURL');
		var $popupHeading = $('#popupHeading');
		var $popupText = $('#popupText');
		var $popupPreviewImg = $('#popupPreviewImg');
		var $select_location = $('#select_location');
		
		var assignedLocations = getAssignedLocations();
		//console.log("assignedLocations: " + JSON.stringify(assignedLocations));
		$('#select_location option').each(function(index,element){
		
		 if(assignedLocations[element.value]&& element.value!=selectedfeature.get('location_id') ){
			$(element).attr('disabled','disabled')
			$(element).addClass("disabled_location");
		 } else {
		 	$(element).removeAttr('disabled')
			$(element).removeClass("disabled_location");
		 }

		 });
		 
		if (selectedfeature.get('location_id')){
		$select_location.val(selectedfeature.get('location_id')).change();
		//	console.log("selectedfeature.get('location_id': " + selectedfeature.get('location_id' ));
	//console.log("select_location.val(): " + $select_location.val() );
		}else {
			$select_location.val(undefined);
		}
		
		// load icon options
		$('#selectedFeatureLonLat').text(ol.proj.toLonLat(feature.getGeometry().getCoordinates()));
		
		$selectedFeatureID.val(selectedfeature.getId());
		if (feature.getGeometry().getType() == 'Circle')
			$selectedFeatureCoord.val(JSON.stringify(selectedfeature.getGeometry().getCenter()))
		else $selectedFeatureCoord.val(JSON.stringify(selectedfeature.getGeometry().getCoordinates()))
		if (selectedfeature.get('marker_type'))
		$marker_type.val(selectedfeature.get('marker_type'));

		
		if (selectedfeature.get('popupPreviewURL')){
		$popupPreviewURL.val(selectedfeature.get('popupPreviewURL')).change();
			//console.log("selectedfeature.get('popupPreviewURL': " + selectedfeature.get('popupPreviewURL' ));
	//console.log("popupPreviewURL.val(): " + $popupPreviewURL.val() );
		}else {
			$popupPreviewURL.val(undefined);
		}
		
		//
		var $lang =$('#lang');
		
		var langKey=$lang.val();
	   // console.log("langKey: " + langKey);
		$popupHeading.val(null);
		$popupText.val(null);
		
		if($lang && langKey ){
			var popupHeadingIntl = selectedfeature.get('popupHeadingIntl') 
			if(popupHeadingIntl) $popupHeading.val(popupHeadingIntl[langKey]);  
			
			var popupTextIntl = selectedfeature.get('popupTextIntl') 
			if(popupTextIntl) 	$popupText.val(popupTextIntl[langKey]); 
			
		//	if(langKey==='en')	{
		//		if(!popupHeadingIntl||!popupHeadingIntl[langKey]) $popupHeading.val(selectedfeature.get('popupHeading')); 
		//		if(!popupTextIntl||!popupTextIntl[langKey]) $popupText.val(selectedfeature.get('popupText')); 
		//	}			
			 
		 } else {		 
			$popupHeading.val(selectedfeature.get('popupHeading')); 
			$popupText.val(selectedfeature.get('popupText')); 
		 }
		 
	
		if(selectedfeature.get('popupPreviewURL'))
		$popupPreviewImg.attr('src',selectedfeature.get('popupPreviewURL'));
		else 	$popupPreviewImg.attr('src','');
	}
}

function getAssignedLocations() {
 var usedLocation={};
	var features = vector_layer.getSource().getFeatures();
	for (var i = 0; i < features.length; i++) {
		var feature = features[i];
			//feature.setStyle(iconMarkerStyle);
			var location_id=  feature.get('location_id')
			if(location_id){
			usedLocation[location_id]=location_id;
			}
	}
	
	return usedLocation;
}

function updateSelectPinboardList() {

	var assignedLocations = getAssignedLocations();
	//console.log("assignedLocations: " + JSON.stringify(assignedLocations));
	$('#select_location_m option').each(function (index, element) {

		if (element.value && !assignedLocations[element.value]) {
			$(element).attr('disabled', 'disabled')
			$(element).addClass("disabled_location");
		} else {
			$(element).removeAttr('disabled')
			$(element).removeClass("disabled_location");
		}

	});

}

function resetPropertiesEditStyle() {
	var features = vector_layer.getSource().getFeatures();
	for (var i = 0; i < features.length; i++) {
		var feature = features[i];
		if (feature.get("type") == "st-marker" && feature.get("gType") == "Point") {
			//feature.setStyle(iconMarkerStyle);
			if(feature.get('isSelected')){
				feature.set('isSelected',false)
				var marker_type = feature.get('marker_type')
			    feature.setStyle(markerStyles[marker_type]['normal']);	
			}
				

		}
	}
}

function unselectFeatureForPropertiesEdit(feature) {}

function updateSelectedFeatureCoordinates() {
	var $selectedFeatureCoord = $('#selectedFeatureCoord');
	$selectedFeatureCoord.val(JSON.stringify(selectedfeature.getGeometry().getCoordinates()));

}

function resetSelectedFeaturePropertiesDisplay() {
	resetPropertiesEditStyle()
	selectedfeature = null;
	$('#editData').hide();
}

var selectedfeature;

function saveLabelDataClicked() {
	var $selectedFeatureCoord = $('#selectedFeatureCoord');
	var $marker_type = $('#marker_type');
	var $popupPreviewURL = $('#popupPreviewURL');
	var $popupPreviewImg = $('#popupPreviewImg');
	var $popupHeading = $('#popupHeading');
	var $popupText = $('#popupText');
	var $select_location = $('#select_location');
	//console.log( "location: "+$select_location.val());
	if ($select_location.val() && $select_location.val() != null)
		selectedfeature.set('location_id', $select_location.val());
	else {
		selectedfeature.set('location_id', undefined);
	}
	// var element = document.getElementById('labelData');
	//-38.146018,145.1119833
	//151.21426597237584,-33.86947573548548
	var selectedFeatureLon = $('#selectedFeatureLon').val();
	var selectedFeatureLat = $('#selectedFeatureLat').val();
	// console.log("selectedFeatureLon: " + selectedFeatureLon);
	// 		 console.log("selectedFeatureLat: " + selectedFeatureLat);

	// console.log("selectedFeatureLat: " + selectedFeatureLat);
	if (selectedFeatureLon && selectedFeatureLat) {
		var unpr = [parseFloat(selectedFeatureLon), parseFloat(selectedFeatureLat)]
		//console.log("unpr: " + JSON.stringify(unpr));
		var c = ol.proj.fromLonLat(unpr)
			//	console.log("c: " + JSON.stringify(c));
		$selectedFeatureCoord.val(JSON.stringify(c))
	
	}

	if (selectedfeature.getGeometry().getType() == 'Circle')
		$selectedFeatureCoord.val(JSON.stringify(selectedfeature.getGeometry().setCenter(JSON.parse($selectedFeatureCoord.val()))))
	else selectedfeature.getGeometry().setCoordinates(JSON.parse($selectedFeatureCoord.val()));
	
	$('#selectedFeatureLonLat').text(ol.proj.toLonLat(selectedfeature.getGeometry().getCoordinates()));
	
	
	selectedfeature.set('marker_type', $marker_type.val());
	if( $popupPreviewURL.val())
	selectedfeature.set('popupPreviewURL', $popupPreviewURL.val());
	else 	selectedfeature.set('popupPreviewURL', undefined);


	var marker_type = selectedfeature.get('marker_type')
	//selectedfeature.setStyle(markerStyles[marker_type]['edit']);	
	$popupPreviewImg.attr('src',selectedfeature.get('popupPreviewURL'));
	updateSelectPinboardList(); 
	
	var $lang =$('#lang');
		
		var langKey=$lang.val();
	   // console.log("langKey: " + langKey);
		
		if($lang && langKey ){
			
			if(!selectedfeature.get('popupHeadingIntl')) selectedfeature.set('popupHeadingIntl',{}) 
			var popupHeadingIntl = selectedfeature.get('popupHeadingIntl') 
			popupHeadingIntl[langKey] = $popupHeading.val();
			
			if(!selectedfeature.get('popupTextIntl')) 	selectedfeature.set('popupTextIntl',{}) ;
			var popupTextIntl = selectedfeature.get('popupTextIntl') 
			popupTextIntl[langKey] = $popupText.val(); 
						
			 
		 } else {		 
			selectedfeature.set('popupHeading', $popupHeading.val());
			selectedfeature.set('popupText', $popupText.val());
		 }
		selectedfeature.setStyle(markerStyles[marker_type]['normal']); 
	selectedfeature.changed();
}

function deleteFeatureClicked() {
	deleteItem(selectedfeature, select_interaction);
}

$('a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
	//console.log('showing tab ' + e.target); // Active Tab
	//console.log('showing tab ' + e.relatedTarget); // Previous Tab
})

$(document).on('shown.bs.tab', 'a[data-toggle="tab"]', function (e) {
	//var activatedTab = e.target; // activated tab
	//console.log('showing tab ' + e.target); // Active Tab
})


function selectMarkerForPinboard(){
popup.hide();
var selectedID = $(select_location_m).val();
	var features = vector_layer.getSource().getFeatures();
	for (var i = 0; i < features.length; i++) {
		var feature = features[i];
			//feature.setStyle(iconMarkerStyle);
			var location_id = feature.get('location_id')
			if(location_id ==selectedID){
				if (feature.get("type") == "st-marker" ) {
					var coord = feature.getGeometry().getCoordinates();
					popup.show(coord, feature.getId() + ':' + feature.get('popupHeading'));
				} 
				return
			}
	}

}